﻿'use strict';

var context;
var employees;

// This code runs when the DOM is ready and creates a context object which is needed to use the SharePoint object model
$(document).ready(function () {
    var hostUrl = getQueryStringValue("SPHostUrl");
    context = SP.ClientContext.get_current();
    var appContextSite = new SP.AppContextSite(context, hostUrl);
    var web = appContextSite.get_web();
    var list = web.get_lists().getByTitle("Employees");
    employees = list.getItems(SP.CamlQuery.createAllItemsQuery());

    context.load(employees,"Include(LastName)");
    context.executeQueryAsync(showNames, function () { alert('Ooops');});

});

function showNames() {
    var empEnum = employees.getEnumerator();
    while (empEnum.moveNext()) {
        $('<p>' + empEnum.get_current().get_item('LastName') + '</p>').appendTo('#results');
    }
}


function getQueryStringValue(paramName) {
    var params = document.URLUnencoded.split("?")[1].split("&");
    var strParams = "";
    for (var i = 0; i < params.length; i = i + 1) {
        var singleParam = params[i].split("=");
        if (singleParam[0] == paramName)
            return decodeURIComponent(singleParam[1]);
    }
}