﻿'use strict';

var context = SP.ClientContext.get_current();
var lists;

// This code runs when the DOM is ready and creates a context object which is needed to use the SharePoint object model
$(document).ready(function () {
    $('#newBtn').click(showAddProject);
    $('#addBtn').click(saveProject);

    getProjects();
});

function getProjects() {
    lists = context.get_web().get_lists();
    context.load(lists,'Include(Title,BaseTemplate,Id)');
    context.executeQueryAsync(showProjects, function () { alert('Oooops');})
}

function showProjects() {
    var le = lists.getEnumerator();
    while (le.moveNext()) {
        if (le.get_current().get_baseTemplate()==10000) {
            $('#projects').append("<div class='projectDiv'><a href='ProjectDetails.aspx?List=" + le.get_current().get_id() + "'>" + le.get_current().get_title() + "</a></div>");
        }
    }
}

function showAddProject() {
    $('#addSection').removeClass('hiddenSection');
    $('#newBtn').addClass('hiddenSection');
}

function saveProject() {
    var name = $('#projectName').val();
    var desc = $('#projectDescription').val();
    var lci = new SP.ListCreationInformation();
    lci.set_description(desc);
    lci.set_templateType(10000);
    lci.set_templateFeatureId('8ae60ed4-22b4-4361-bb98-b04d2aa4e80a')
    lci.set_title(name);
    var list = context.get_web().get_lists().add(lci);
    list.update();
    context.executeQueryAsync(function ()
    {
        $('#addSection').addClass('hiddenSection');
        $('#newBtn').removeClass('hiddenSection');
        $('#projects div').remove();
        getProjects();
    }, function (a, b) {
        alert('oooops');
    });
    
}


