﻿'use strict';

var context = SP.ClientContext.get_current();
var list;
var items;

$(function () {
    $('#newEntry').click(newEntry);

    getListInfo();
});

function getListInfo() {
    var listId = getQueryStringValue("List");
    list = context.get_web().get_lists().getById(listId);
    items = list.getItems(SP.CamlQuery.createAllItemsQuery());

    context.load(list, "Title", "Description");
    context.load(items);
    context.executeQueryAsync(showListInfo, function (a,b) { alert('Ooooops');});
}

function showListInfo() {
    $('#projectTitle').html(list.get_title());
    $('#projectDescription').html(list.get_description());
    var itemlooper = items.getEnumerator();
    while (itemlooper.moveNext()) {
        var item = itemlooper.get_current();
        $('#entries tbody').append('<tr><td>' + item.get_item("EmployeeName") + '</td><td>' + item.get_item("Hours") + '</td><td>' + item.get_item("ActivityType") + '</td><td></td></tr>');
    }
}

function getQueryStringValue(paramName) {
    var params = document.URLUnencoded.split("?")[1].split("&");
    var strParams = "";
    for (var i = 0; i < params.length; i = i + 1) {
        var singleParam = params[i].split("=");
        if (singleParam[0] == paramName)
            return decodeURIComponent(singleParam[1]);
    }
}

function newEntry() {
    var line = "<tr><td><input id='newEmp' type='text' /></td><td><input id='newHours' type='text' /></td><td><input id='newActivity' type='text' /></td><td><input id='saveBtn' type='button' value='save' /></td></tr>"
    $('#entries tbody').prepend(line);

    $('#saveBtn').click(function () {
        var name = $('#newEmp').val();
        var hours = $('#newHours').val();
        var type = $('#newActivity').val();

        var newItem = list.addItem();
        newItem.set_item("EmployeeName", name);
        newItem.set_item("Hours", hours);
        newItem.set_item("ActivityType", type);
        newItem.update();

        context.executeQueryAsync(function () { document.location.reload(true);}, function () { alert('Oooops');});
    });
}

//function newEntry() {
//    var options = {
//        url: 'newEntry.aspx',
//        title: 'new Timesheet Entry',
//        allowMaximize: true,
//        showClose: true,
//        width: 700,
//        height: 700,
//        dialogReturnValueCallback: processNewEntry
//    };

//    SP.UI.ModalDialog.showModalDialog(options);
//}

function processNewEntry(dialogResult, returnValue) {
    if (dialogResult==SP.UI.DialogResult.OK) {
        var newItem = list.addItem();
        newItem.set_item("EmployeeName", returnValue.EmployeeName);
        newItem.set_item("Hours", returnValue.Hours);
        newItem.set_item("ActivityType", returnValue.ActivityType);
        newItem.update();

        context.executeQueryAsync(function () { document.location.reload(true); }, function () { alert('Oooops'); });
    }
}