﻿'use strict';


// This code runs when the DOM is ready and creates a context object which is needed to use the SharePoint object model
$(document).ready(function () {
    $('#newBtn').click(showAddProject);
    $('#addBtn').click(saveProject);

    getProjects();
});

function getProjects() {
    var url = _spPageContextInfo.webAbsoluteUrl + "/_api/web/lists?$filter=BaseTemplate eq 10000&$select=Title,Id";
    $.ajax({
        type: 'GET',
        url: url,
        headers: { accept: 'application/json;odata=verbose' },
        contentType: 'application/json;odata=verbose',
        error: function () { alert('Ooops'); },
        success: showProjects
    });
}

function showProjects(data) {
    var d = data.d.results;
    for (var i = 0; i < d.length; i++) {
        $('#projects').append("<div class='projectDiv'><a href='ProjectDetails.aspx?List=" + d[i].Id + "'>" + d[i].Title + "</a></div>");
    }
}

function showAddProject() {
    $('#addSection').removeClass('hiddenSection');
    $('#newBtn').addClass('hiddenSection');
}

function saveProject() {
    var name = $('#projectName').val();
    var desc = $('#projectDescription').val();
    var url = _spPageContextInfo.webAbsoluteUrl + "/_api/web/lists";
    
    var newList = {
        Description: desc,
        BaseTemplate: 10000,
        TemplateFeatureId: '8ae60ed4-22b4-4361-bb98-b04d2aa4e80a',
        Title: name,
        __metadata: {type: 'SP.List'}
    };


    $.ajax({
        type: 'POST',
        url: url,
        data: JSON.stringify(newList),
        headers: {
            "accept": 'application/json;odata=verbose',
            "X-RequestDigest": $('#__REQUESTDIGEST').val()
        },
        contentType: 'application/json;odata=verbose',
        error: function (a, b, c) { alert('Ooops'); },
        success: function () {
            $('#addSection').addClass('hiddenSection');
            $('#newBtn').removeClass('hiddenSection');
            $('#projects div').remove();
            getProjects();
        }
    });

    
}


