﻿'use strict';

var context = SP.ClientContext.get_current();
var listId;

$(function () {
    $('#newEntry').click(newEntry);

    getListInfo();
});

function getListInfo() {
    var listId = getQueryStringValue("List");

    var url = _spPageContextInfo.webAbsoluteUrl + "/_api/web/lists/getById('" + listId + "')?$select=Title,Description,Id";
    $.ajax({
        type: 'GET',
        url: url,
        headers: { accept: 'application/json;odata=verbose' },
        contentType: 'application/json;odata=verbose',
        error: function (a, b, c) { alert('Ooops.'); },
        success: showListInfo
    });
}

function showListInfo(data) {
    var list = data.d;

    $('#projectTitle').html(list.Title);
    $('#projectDescription').html(list.Description);
    listId = list.Id;

    var url = _spPageContextInfo.webAbsoluteUrl + "/_api/web/lists/getById('" + list.Id + "')/Items?$select=EmployeeName, Hours, ActivityType";

    $.ajax({
        type: 'GET',
        url: url,
        headers: { accept: 'application/json;odata=verbose' },
        contentType: 'application/json;odata=verbose',
        error: function (a, b, c) { alert('Ooops. Maybe there is no data'); },
        success: function (data) {
            var items = data.d.results;
            for (var i = 0; i < items.length; i++) {
                $('#entries tbody').append('<tr><td>' + items[i].EmployeeName + '</td><td>' + items[i].Hours + '</td><td>' + items[i].ActivityType + '</td><td></td></tr>');
            }
        }
    });
}

function getQueryStringValue(paramName) {
    var params = document.URLUnencoded.split("?")[1].split("&");
    var strParams = "";
    for (var i = 0; i < params.length; i = i + 1) {
        var singleParam = params[i].split("=");
        if (singleParam[0] == paramName)
            return decodeURIComponent(singleParam[1]);
    }
}

function newEntry() {
    var options = {
        url: 'newEntry.aspx',
        title: 'new Timesheet Entry',
        allowMaximize: true,
        showClose: true,
        width: 700,
        height: 700,
        dialogReturnValueCallback: processNewEntry
    };

    SP.UI.ModalDialog.showModalDialog(options);
}

function processNewEntry(dialogResult, returnValue) {
    if (dialogResult == SP.UI.DialogResult.OK) {
        var url = _spPageContextInfo.webAbsoluteUrl + "/_api/web/lists/getById('" + listId + "')/Items";

        var data = {
            EmployeeName: returnValue.EmployeeName,
            Hours: returnValue.Hours,
            ActivityType: returnValue.ActivityType,
            __metadata : {type:"SP.ListItem"}
        };

        $.ajax({
            type: 'POST',
            url: url,
            data: JSON.stringify(data),
            headers: {
                "accept": 'application/json;odata=verbose',
                "X-RequestDigest": $('#__REQUESTDIGEST').val()
            },
            contentType: 'application/json;odata=verbose',
            error: function (a, b, c) { alert('Ooops'); },
            success: function () {
                document.location.reload(true);
            }
        });
        
    }
}